
% \chapter{Skripte}
%	\lstinputlisting[caption={Converterprogramm von alten zu neuen Konfigurationsdateien},label=app:conv]{Quellen/env2imp.java}
%	\lstinputlisting[language=ANT,caption={Angepastes Ant-Buildskript},label=app:antinstall]{Quellen/build.xml}
%	\lstinputlisting[caption={Batchdatei zum Automatischen Verteilen},language=command.com,label=app:batchjenkins]{Quellen/depoly_DMSCore.bat}
% \chapter{Konfigurationen}
%	\lstinputlisting[caption={Alte Konfiguration},label=konf:oldkonf]{Quellen/Environment.properties}
%	\lstinputlisting[caption={Importdatei mit den Werten der alten Konfigurationsdatei},language=XML,label=konf:xmlfuerdms]{Quellen/out.xml}

\chapter{Source Code}
% Verweis aufs Repository...
Der gesamte Source Code inklusive diesem Dokument ist auf GitLab verfügbar \\ (\url{https://gitlab.com/wude/training/swo-rtos-kernel}).

% Zu spät dafür:
% Die darin enthaltene Datei \enquote{\texttt{README.md}} erklärt die Struktur des Projekts und seine Verwendung.

% Zu einigen in diesem Dokument dargestellten, Listings liegt ebenfalls eine Datei mit dem Source Code vor.

\section{\texttt{SchedulingTreeIterator\_Next}}
\label{app:schedulingtreeiteratornext}

\begin{lstlisting}[
	style=cpp,
	label={lis:schedulingtreeiterator_next},
	caption={\texttt{SchedulingTreeIterator\_Next}},
]
SchedulingTreeSlot_t* SchedulingTreeIterator_Next(SchedulingTreeIterator_t* pIterator) {
	pIterator->pSlot = pIterator->pSlot->pNext;
	while (pIterator->pSlot == NULL) {
		pIterator->pNode = pIterator->pNode->apChilds[
			(pIterator->branchIndex >> pIterator->periodIndex) & 1];
		--pIterator->periodIndex;
		if (pIterator->pNode != NULL) {
			pIterator->pSlot = pIterator->pNode->pSlot;
		} else {
			if (++pIterator->branchIndex >= pIterator->pTree->branchCount) {
				pIterator->branchIndex = 0;
				++pIterator->cycleCount;
			}
			pIterator->periodIndex = pIterator->pTree->maxPeriodExponent - 1;
			pIterator->pNode       = pIterator->pTree->pRoot;
			pIterator->pSlot       = pIterator->pNode->pSlot;
		}
	}
	return pIterator->pSlot;
}
\end{lstlisting}

\clearpage

\section{\texttt{SelectNextTask}}
\label{app:selectnexttask}

\begin{lstlisting}[
	style=cpp,
	label={lis:selectnexttask},
	caption={\texttt{SelectNextTask}},
]
/** @brief Select the next task. A new task will be set in any case. */
static void SelectNextTask() {
	SchedulingTreeSlot_t* pSlot = SchedulingTreeIterator_Next(&g_schedulingIterator);
	if (pSlot->pPeriodicTask != NULL) {
		g_pNextTaskControlBlock = pSlot->pPeriodicTask->base.pControlBlock;
		g_lastTaskSwitchTimeMs  = g_elapsedSystemTimeMs;
		g_nextTaskSwitchTimeMs  = g_lastTaskSwitchTimeMs + pSlot->pPeriodicTask->durationMs;

		if (!g_pNextTaskControlBlock->isRunning) {
			// A periodic task ended before suspension. It has to be prepared for its next execution.
			g_pNextTaskControlBlock->isRunning = true;
			PrepareTaskStack(g_pNextTaskControlBlock);
		}
	} else {
		SelectNextTaskNonPeriodic(pSlot->freeDurationMs);
	}
}
\end{lstlisting}

\clearpage

\section{\texttt{SelectNextTaskNonPeriodic}}
\label{app:selectnexttasknonperiodic}

\begin{lstlisting}[
	style=cpp,
	label={lis:selectnexttasknonperiodic},
	caption={\texttt{SelectNextTaskNonPeriodic}},
]
/** @brief Select the next task among the non-periodic tasks. A new task will be set in any case.

	@param [in] freeDurationMs Free execution duration.
*/
static void SelectNextTaskNonPeriodic(uint32_t freeDurationMs) {
	// What is the next sporadic task to execute?
	// Sporadic tasks are sorted by their deadline beginning with the lowest.
	// Aperiodic tasks are always prioritized lower.
	SporadicTask_t* pSporadicTask = SporadicTaskChain_GetItemNullable(g_sporadicTaskChain.pFirst);
	if (pSporadicTask != NULL) {
		SporadicTaskChain_Remove(&g_sporadicTaskChain, pSporadicTask);
		g_pNextTaskControlBlock = pSporadicTask->base.pControlBlock;
	} else {
		// What is the next aperiodic task to execute?
		// Aperiodic tasks are sorted by their priority beginning with the highest (numerically lowest).
		AperiodicTask_t* pAperiodicTask = AperiodicTaskChain_GetItemNullable(g_aperiodicTaskChain.pFirst);
		if (pAperiodicTask != NULL) {
			AperiodicTaskChain_Remove(&g_aperiodicTaskChain, pAperiodicTask);
			g_pNextTaskControlBlock = pAperiodicTask->base.pControlBlock;
		} else {
			// No aperiodic or sporadic task to select from. Instate the idle task.
			g_pNextTaskControlBlock = &g_idleTaskControlBlock;
		}
	}
	g_lastTaskSwitchTimeMs = g_elapsedSystemTimeMs;
	g_nextTaskSwitchTimeMs = g_lastTaskSwitchTimeMs + freeDurationMs;
}
\end{lstlisting}

\clearpage

\section{\texttt{SVC\_Handler}}

\begin{lstlisting}[
	style=cpp,
	label={lis:svc_handler},
	caption={\texttt{SVC\_Handler}},
]
/** @brief The supervisor call handler (IRQ: SVC). */
__attribute__((naked)) void SVC_Handler(void) {
	// EXC_RETURN indicates which stack is used.
	asm volatile("TST   LR, 0b100");
	asm volatile("ITE   EQ");      // If Equal Then Else.
	asm volatile("MRSEQ R1, MSP"); // `0` -> Store MSP.
	asm volatile("MRSNE R1, PSP"); // `1` -> Store PSP.
	// Get the PC inside the caller stack frame.
	asm volatile("LDR   R0, [R1, 24]");
	// Get the service code from inside the SVC instruction.
	asm volatile("LDRB  R0, [R0, -2]");
	// R0 and R1 are the call arguments.
	asm volatile("B SVC_Handler_Internal");
}

void SVC_Handler_Internal(ServiceCode_t serviceCode, CallerStackFrame_t* pCallerStackFrame) {
	switch (serviceCode) {
	case ServiceCode_StartKernel: PrepareFirstTask(); break;
	case ServiceCode_Yield: Yield(); break;
	case ServiceCode_StartSporadicTask:
		pCallerStackFrame->R0 =
			StartSporadicTask((SporadicTask_t*)(intptr_t)pCallerStackFrame->R0, pCallerStackFrame->R1);
		break;
	case ServiceCode_StartAperiodicTask:
		pCallerStackFrame->R0 = StartAperiodicTask((AperiodicTask_t*)(intptr_t)pCallerStackFrame->R0);
		break;
	}
}
\end{lstlisting}

\clearpage

\section{\texttt{PendSV\_Handler}}
\label{app:pendsv_handler}

\begin{lstlisting}[
	style=cpp,
	label={lis:pendsv_handler},
	caption={\texttt{PendSV\_Handler}},
]
/** @brief The pendable service call handler (IRQ: PendSV).

	Will switch the current task when there is a next task.
*/
__attribute__((naked)) void PendSV_Handler() {
	// Get the current and next task control block.
	asm volatile("LDR       R1,     =g_pCurrentTaskControlBlock");
	asm volatile("LDR       R2,     =g_pNextTaskControlBlock");

	// The stack pointer is the first member in a task control block.
	// That means `R3` is a pointer to the stack pointer and a pointer to the task control block.
	asm volatile("LDR       R3,     [R1]");
	asm volatile("LDR       R0,     [R2]");

	// End here if current and next task are the same. This should not normally be the case.
	asm volatile("CMP       R3,     R0");
	asm volatile("BEQ       SkipContextSwitch");

	// Get the "Process Stack Pointer"
	asm volatile("MRS       R0,     PSP");
	asm volatile("DSB");
	asm volatile("ISB");

	// ----------------------------------------
	// In case the Floating-Point Unit was used, store the FPU callee stack frame.
	asm volatile("TST       LR,     0x10");
	asm volatile("IT        EQ");
	asm volatile("VSTMDBEQ  R0!,    {S16-S31}");

	// Store the basic callee stack frame.
	asm volatile("STMDB     R0!,    {R4-R11, LR}");
	// Store the modified stack pointer into the current task.
	asm volatile("STR       R0,     [R3]");

	// ----------------------------------------
	// The next task becomes the current task.
	asm volatile("LDR       R3,     [R2]");
	asm volatile("STR       R3,     [R1]");

	// ----------------------------------------
	// Load the stack pointer of the next task.
	asm volatile("LDR       R0,     [R3]");
	// Load the basic callee stack frame of the next task.
	asm volatile("LDMIA     R0!,    {R4-R11, LR}");

	// In case the Floating-Point Unit was used, load the FPU callee stack frame.
	asm volatile("TST       LR,     0x10");
	asm volatile("IT        EQ");
	asm volatile("VLDMIAEQ  R0!,    {S16-S31}");

	// ----------------------------------------
	// Prepare "Process Stack Pointer"
	asm volatile("MSR       PSP,    R0");
	asm volatile("DSB");
	asm volatile("ISB");

	asm volatile("SkipContextSwitch:");
	asm volatile("BX        LR");
}
\end{lstlisting}

% \begin{lstlisting}[
% 	style=asm_arm,
% 	label={lis:pendsv_handler},
% 	caption={\texttt{PendSV\_Handler}},
% ]
% PendSV_Handler PROC
% 	EXPORT PendSV_Handler
% 	IMPORT currentTask
% 	IMPORT nextTask

% 	; Get the current and next task control block.
% 	LDR       R1,     =g_pCurrentTaskControlBlock
% 	LDR       R2,     =g_pNextTaskControlBlock

% 	; The stack pointer is the first member in a task control block.
% 	; That means `R3` is a pointer to the stack pointer and a pointer to the task control block.
% 	LDR       R3,     [R1]
% 	LDR       R0,     [R2]

% 	; End here if current and next task are the same. This should not normally be the case.
% 	CMP       R3,     R0
% 	BEQ       SkipContextSwitch

% 	; Get the "Process Stack Pointer"
% 	MRS       R0,     PSP
% 	DSB
% 	ISB

% 	; ----------------------------------------
% 	; In case the Floating-Point Unit was used, store the FPU callee stack frame.
% 	TST       LR,     0x10
% 	IT        EQ
% 	VSTMDBEQ  R0!,    {S16-S31}

% 	; Store the basic callee stack frame.
% 	STMDB     R0!,    {R4-R11, LR}
% 	; Store the modified stack pointer into the current task.
% 	STR       R0,     [R3]

% 	; ----------------------------------------
% 	; The next task becomes the current task.
% 	LDR       R3,     [R2]
% 	STR       R3,     [R1]

% 	; ----------------------------------------
% 	; Load the stack pointer of the next task.
% 	LDR       R0,     [R3]
% 	; Load the basic callee stack frame of the next task.
% 	LDMIA     R0!,    {R4-R11, LR}

% 	; In case the Floating-Point Unit was used, load the FPU callee stack frame.
% 	TST       LR,     0x10
% 	IT        EQ
% 	VLDMIAEQ  R0!,    {S16-S31}

% 	; ----------------------------------------
% 	; Prepare "Process Stack Pointer"
% 	MSR       PSP,    R0
% 	DSB
% 	ISB

% SkipContextSwitch:
% 	BX        LR
% END
% \end{lstlisting}
